<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="MetaModules|Segmentation and  Firewall Testing">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>Segmentation and Firewall Testing MetaModule</title>
        
        <link href="../../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../../index.html#18-metamodules/segmentation-firewall/segmentation-firewall-testing.html">Open topic with navigation</a>
        </p>
        <h1>Segmentation and Firewall Testing MetaModule</h1>
        <p>When firewalls have badly configured or lax egress traffic filtering policies, they open the network up to attacks from reverse shells, data-exfiltration, and other forms of exploitation.  In order to identify the open ports that allow outbound traffic and to verify that your egress filtering policies properly block traffic, you can run the Segmentation and Firewall Testing MetaModule. 

</p>
        <p>The MetaModule runs an Nmap SYN scan against  an egress target to reveal the outbound ports that are open from an internal host. It

 identifies the state of the ports in your firewall based on the traffic received by the server. If the server receives the traffic, then the MetaModule flags the port as open. If the firewall blocks the traffic, the MetaModule flags the port as filtered. The MetaModule tags the remaining ports as unfiltered or closed depending on the their response to connections. 

After the MetaModule completes its run, it generates a report that provides you with a comprehensive look at port state distribution and unfiltered ports. </p>
        <h2>Egress Scan Target</h2>
        <p>The egress target, egadz.metasploit.com, is a server hosted by Rapid7 and has been set up to have all 65,535 ports open.  Each port is configured to respond with a single SYN-ACK packet. In its default configuration, the MetaModule initiates a port scan using Nmap’s default 1000 most common ports; however, if you need to include additional ports, you can define a custom port range.</p>
        <h2>Port States</h2>
        <p>The Segmentation and Firewall Testing&#160;MetaModule uses the following states to categorize ports. </p>
        <ul>
            <li value="1"><b>Open</b>	 - A port is assigned an open state if it allows traffic out of the network and the EGADZ server receives it. An open state indicates that there is an application that is actively accepting TCP connections, UDP datagrams or SCTP associations. </li>
            <li value="2"><b>Filtered</b>	- A port is assigned a filtered state if it drops the traffic before it reaches the desired port on the EGADZ server. It will not receive a response from the EGADZ server. Typically, a port has a filtered state if a dedicated firewall device, router rules, or host-based firewall software has successfully blocked the port from sending traffic. </li>
            <li value="3"><b>Closed</b>	- A port is assigned a closed state if it allows traffic through the port, but there is not an application or service bound to the port. A closed port can be used to determine if t a host is up on an IP&#160;address. </li>
            <li value="4"><b>Unfiltered</b> - A port is assigned an unfiltered traffic if it allows traffic through to the port, but it cannot be determined whether the port is open or closed.</li>
        </ul>
        <h2>Setting Up an Egress Testing Server</h2>
        <p>The Firewall Egress Testing&#160;MetaModule uses an external server hosted by Rapid7 to identify open outbound ports from an internal host.   In some cases, you may want to set up and your own egress testing server. For example, if you want to test egress between different endpoints or if you do not want to send data to a server on the Internet, you can set up a custom egress testing server. </p>
        <p>To help you set up a custom egress testing server, <span class="VariablesProductName">Metasploit Pro</span> provides you with a script that you can run on an Ubuntu 12.04 LTS server. The script is downloadable from the Projects page in <span class="VariablesProductName">Metasploit Pro</span>.</p>
        <h3>Egress Testing Server Requirements       </h3>
        <p>To set up an egress testing server, you need to perform the following tasks:</p>
        <ol>
            <li value="1">Set up a Linux machine with your favorite distribution.</li>
            <li value="2">Add two network interfaces, or network adaptors, to the Linux machine. Each network interface should have an IP address. <br /><br />For more information on setting up a network interface on a virtual machine, please visit the documentation for your virtualization software. <br /></li>
            <li value="3">Assign one IP&#160;address as the administrative interface. This interface will be used to control the egress testing server. It should be assigned to the eth0 interface.&#160;</li>
            <li value="4">Assign the second IP address as the egress testing server. This interface should be assigned to the eth1 interface.</li>
            <li value="5">Download and run the egress testing server script. </li>
        </ol>
        <h3>Set Up a Custom Egress Target</h3>
        <p>To set up a custom egress target, you will need an Ubuntu 12.04 box that is configured with two IP addresses. </p>
        <p>The two IP&#160;addresses are needed for the following interfaces:</p>
        <ul>
            <li value="1"><b>The admin interface</b> - This is usually found on the eth0 interface and will be used for controlling the egress server.  </li>
            <li value="2"><b>The egress server</b> - This is usually found on eth1, or a virtual interface such as eth0:1.  This is the IP address you will scan from the Firewall and Segmentation Testing MetaModule.</li>
        </ul>
        <p>After you set up the box with two addresses, perform the following steps:</p>
        <ol>
            <li value="1">Log in to the <span class="VariablesProductName">Metasploit Pro</span> web interface. </li>
            <li value="2">Click the Segmentation <b class="UISelection">Target Setup Script</b> button located under the Global Tools. <br></br><br></br><img src="../../Resources/Images/diablo-test-plan/egress-script-button_455x114.png" style="width: 455;height: 114;"></img><br></br><br></br>The download process will automatically start.<br></br><br></br>If your browser is not configured to automatically download files, a dialog window will appear and prompt you to save the file. You will need to save the file to your computer.<br></br></li>
            <li value="3">Follow the instructions provided in the <code>create-egadz.sh</code> script to set up the egress target. </li>
            <li value="4">Verify that you are able to set up an egress target using the instructions. </li>
        </ol>
        <p>After you have set up the egress target, you can run the Segmentation and Firewall Testing MetaModule.</p>
        <h2>Running the Segmentation and Firewall Testing MetaModule</h2>
        <ol>
            <li value="1"> 

From within a project, select <b class="UISelection">Modules &gt; MetaModules</b>. <br /><br /><img src="../../Resources/Images/metamodules/metamodules-firewall-egress-apps-tab_549x71.png" style="width: 549;height: 71;" /></li>
            <li value="2">Find the <b class="UISelection">Segmentation and Firewall Testing MetaModule</b> and click the <b class="UISelection">Launch </b>button. <br /><br /><img src="../../Resources/Images/metamodules/metamodules-firewall-egress-metamodule-1_550x263.png" style="width: 550;height: 263;" /><br /><br />The Segmentation and Firewall Testing configuration window appears.</li>
            <li value="3">From the Scan Config tab, choose one of the following scan target options:</li>
        </ol>
        <ul>
            <li class="numberedList2" value="1">Use default egress target - The MetaModule runs against the egress server that Metasploit has set up for testing outbound traffic. </li>
            <li class="numberedList2" value="2">Use a custom egress target - The MetaModule runs against a server that you have set up for testing outbound traffic. You can specify an IP or a fully qualified domain name. To learn how to set up a custom egress target, go to the Global Tools area located on the Projects page and download the Segmentation Target Setup Script. You can follow the instructions provided in the script to create a custom egress server. </li>
        </ul>
        <ol>
            <li value="4">From the Scan Config tab, choose one of the following port range options:</li>
        </ol>
        <ul>
            <li class="indentedList" value="1"> <![CDATA[ ]]><b class="UISelection">Use default nmap port set</b> -  Scans Nmap’s 1000 most common ports.</li>
            <li class="indentedList" value="2"> <![CDATA[ ]]><b class="UISelection">Use a custom port range</b> option - Scans the range of ports that you define. <br /><br /><img src="../../Resources/Images/metamodules/metamodules-firewall-egress-configuration-1_283x200.png" style="width: 283;height: 200;" /></li>
        </ul>
        <ol start="4">
            <li value="5">Click the <b class="UISelection">Generate Report</b> tab.The Report configuration form appears.</li>
            <li value="6">Enter a name for the report in the <b class="UISelection">Report Name</b> field, if you want to use a custom report name.  Otherwise, the MetaModule uses the default report name.<br /><br /><img src="../../Resources/Images/metamodules/metamodules-firewall-egress-report-1_300x214.png" style="width: 300;height: 214;" /></li>
            <li value="7">From the <b class="UISelection">Sections</b> area, deselect any sections you do not want to include in the report. Skip this step if you want to generate all the report sections.</li>
            <li value="8">Select the <b class="UISelection">Email Report</b> option if you want to e-mail the report after it generates. If you enable this option, you need to supply a comma separated list of e-mail addresses.</li>
        </ol>
        <p class="NoteList" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>If you want to e-mail a report, you must set up a local mail server or e-mail relay service for <span class="VariablesProductName">Metasploit Pro</span> to use. To define mail server settings, select <b class="UISelection">Administration &gt; Global Settings &gt; SMTP Settings</b>.</p>
        <ol data-mc-continue="true">
            <li value="9">Click the <b class="UISelection">Launch </b>button.</li>
        </ol>
        <p>&#160;</p>
    </body>
</html>